Package icyllis.modernui.animation

# Class LayoutTransition

java.lang.Object
icyllis.modernui.animation.LayoutTransition

public class LayoutTransition extends Object
This class enables automatic animations on layout changes in ViewGroup objects. To enable transitions for a layout container, create a LayoutTransition object and set it on any ViewGroup by calling `ViewGroup.setLayoutTransition(LayoutTransition)`. This will cause default animations to run whenever items are added to or removed from that container. To specify custom animations, use the `setAnimator()` method.

One of the core concepts of these transition animations is that there are two types of changes that cause the transition and four different animations that run because of those changes. The changes that trigger the transition are items being added to a container (referred to as an "appearing" transition) or removed from a container (also known as "disappearing"). Setting the visibility of views (between GONE and VISIBLE) will trigger the same add/remove logic. The animations that run due to those events are one that animates items being added, one that animates items being removed, and two that animate the other items in the container that change due to the add/remove occurrence. Users of the transition may want different animations for the changing items depending on whether they are changing due to an appearing or disappearing event, so there is one animation for each of these variations of the changing event. Most of the API of this class is concerned with setting up the basic properties of the animations used in these four situations, or with setting up custom animations for any or all of the four.

By default, the DISAPPEARING animation begins immediately, as does the CHANGE_APPEARING animation. The other animations begin after a delay that is set to the default duration of the animations. This behavior facilitates a sequence of animations in transitions as follows: when an item is being added to a layout, the other children of that container will move first (thus creating space for the new item), then the appearing animation will run to animate the item being added. Conversely, when an item is removed from a container, the animation to remove it will run first, then the animations of the other children in the layout will run (closing the gap created in the layout when the item was removed). If this default choreography behavior is not desired, the `setDuration(int, long)` and `setStartDelay(int, long)` of any or all of the animations can be changed as appropriate. Keep in mind, however, that if you start an APPEARING animation before a DISAPPEARING animation is completed, the DISAPPEARING animation stops, and any effects from the DISAPPEARING animation are reverted. If you instead start a DISAPPEARING animation before an APPEARING animation is completed, a similar set of effects occurs for the APPEARING animation.

The animations specified for the transition, both the defaults and any custom animations set on the transition object, are templates only. That is, these animations exist to hold the basic animation properties, such as the duration, start delay, and properties being animated. But the actual target object, as well as the start and end values for those properties, are set automatically in the process of setting up the transition each time it runs. Each of the animations is cloned from the original copy and the clone is then populated with the dynamic values of the target being animated (such as one of the items in a layout container that is moving as a result of the layout event) as well as the values that are changing (such as the position and size of that object). The actual values that are pushed to each animation depends on what properties are specified for the animation. For example, the default CHANGE_APPEARING animation animates the `left`, `top`, `right`, `bottom`, `scrollX`, and `scrollY` properties. Values for these properties are updated with the pre- and post-layout values when the transition begins. Custom animations will be similarly populated with the target and values being animated, assuming they use ObjectAnimator objects with property names that are known on the target object.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static interface`
  `LayoutTransition.TransitionListener`
  This interface is used for listening to starting and ending events for transitions.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `APPEARING`
  A flag indicating the animation that runs on those items that are appearing in the container.
  `static final int`
  `CHANGE_APPEARING`
  A flag indicating the animation that runs on those items that are changing due to a new item appearing in the container.
  `static final int`
  `CHANGE_DISAPPEARING`
  A flag indicating the animation that runs on those items that are changing due to an item disappearing from the container.
  `static final int`
  `CHANGING`
  A flag indicating the animation that runs on those items that are changing due to a layout change not caused by items being added to or removed from the container.
  `static final int`
  `DISAPPEARING`
  A flag indicating the animation that runs on those items that are disappearing from the container.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LayoutTransition()`
  Constructs a LayoutTransition object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addChild(ViewGroup parent, View child)`
  This method is called by ViewGroup when a child view is about to be added to the container.
  `void`
  `addTransitionListener(LayoutTransition.TransitionListener listener)`
  Add a listener that will be called when the bounds of the view change due to layout processing.
  `void`
  `disableTransitionType(int transitionType)`
  Disables the specified transitionType for this LayoutTransition object.
  `void`
  `enableTransitionType(int transitionType)`
  Enables the specified transitionType for this LayoutTransition object.
  `Animator`
  `getAnimator(int transitionType)`
  Gets the animation used during one of the transition types that may run.
  `long`
  `getDuration(int transitionType)`
  Gets the duration on one of the animation objects used by this transition.
  `TimeInterpolator`
  `getInterpolator(int transitionType)`
  Gets the interpolator on one of the animation objects used by this transition.
  `long`
  `getStagger(int transitionType)`
  Gets the length of time to delay between starting each animation during one of the change animations.
  `long`
  `getStartDelay(int transitionType)`
  Gets the start delay on one of the animation objects used by this transition.
  `List<LayoutTransition.TransitionListener>`
  `getTransitionListeners()`
  Gets the current list of listeners for layout changes.
  `void`
  `hideChild(ViewGroup parent, View child, int newVisibility)`
  This method is called by ViewGroup when a child view is about to be hidden in container.
  `boolean`
  `isChangingLayout()`
  Returns true if animations are running which animate layout-related properties.
  `boolean`
  `isRunning()`
  Returns true if any of the animations in this transition are currently running.
  `boolean`
  `isTransitionTypeEnabled(int transitionType)`
  Returns whether the specified transitionType is enabled for this LayoutTransition object.
  `void`
  `removeChild(ViewGroup parent, View child)`
  This method is called by ViewGroup when a child view is about to be removed from the container.
  `void`
  `removeTransitionListener(LayoutTransition.TransitionListener listener)`
  Remove a listener for layout changes.
  `void`
  `setAnimateParentHierarchy(boolean animateParentHierarchy)`
  This flag controls whether CHANGE_APPEARING or CHANGE_DISAPPEARING animations will cause the default changing animation to be run on the parent hierarchy as well.
  `void`
  `setAnimator(int transitionType, Animator animator)`
  Sets the animation used during one of the transition types that may run.
  `void`
  `setDuration(int transitionType, long duration)`
  Sets the duration on one of the animation objects used by this transition.
  `void`
  `setDuration(long duration)`
  Sets the duration to be used by all animations of this transition object.
  `void`
  `setInterpolator(int transitionType, TimeInterpolator interpolator)`
  Sets the interpolator on one of the animation objects used by this transition.
  `void`
  `setStagger(int transitionType, long duration)`
  Sets the length of time to delay between starting each animation during one of the change animations.
  `void`
  `setStartDelay(int transitionType, long delay)`
  Sets the start delay on one of the animation objects used by this transition.
  `void`
  `showChild(ViewGroup parent, View child, int oldVisibility)`
  This method is called by ViewGroup when a child view is about to be made visible in the container.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### CHANGE_APPEARING

    public static final int CHANGE_APPEARING
    A flag indicating the animation that runs on those items that are changing due to a new item appearing in the container.
    See Also:
      - Constant Field Values

  - ### CHANGE_DISAPPEARING

    public static final int CHANGE_DISAPPEARING
    A flag indicating the animation that runs on those items that are changing due to an item disappearing from the container.
    See Also:
      - Constant Field Values

  - ### APPEARING

    public static final int APPEARING
    A flag indicating the animation that runs on those items that are appearing in the container.
    See Also:
      - Constant Field Values

  - ### DISAPPEARING

    public static final int DISAPPEARING
    A flag indicating the animation that runs on those items that are disappearing from the container.
    See Also:
      - Constant Field Values

  - ### CHANGING

    public static final int CHANGING
    A flag indicating the animation that runs on those items that are changing due to a layout change not caused by items being added to or removed from the container. This transition type is not enabled by default; it can be enabled via `enableTransitionType(int)`.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### LayoutTransition

    public LayoutTransition()
    Constructs a LayoutTransition object. By default, the object will listen to layout events on any ViewGroup that it is set on and will run default animations for each type of layout event.

- ## Method Details

  - ### setDuration

    public void setDuration(long duration)
    Sets the duration to be used by all animations of this transition object. If you want to set the duration of just one of the animations in particular, use the `setDuration(int, long)` method.
    Parameters:
      `duration` - The length of time, in milliseconds, that the transition animations should last.

  - ### enableTransitionType

    public void enableTransitionType(int transitionType)
    Enables the specified transitionType for this LayoutTransition object. By default, a LayoutTransition listens for changes in children being added/remove/hidden/shown in the container, and runs the animations associated with those events. That is, all transition types besides `CHANGING` are enabled by default. You can also enable `CHANGING` animations by calling this method with the `CHANGING` transitionType.
    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`.

  - ### disableTransitionType

    public void disableTransitionType(int transitionType)
    Disables the specified transitionType for this LayoutTransition object. By default, all transition types except `CHANGING` are enabled.
    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`.

  - ### isTransitionTypeEnabled

    public boolean isTransitionTypeEnabled(int transitionType)
    Returns whether the specified transitionType is enabled for this LayoutTransition object. By default, all transition types except `CHANGING` are enabled.
    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`.
    Returns:
      true if the specified transitionType is currently enabled, false otherwise.

  - ### setStartDelay

    public void setStartDelay(int transitionType, long delay)
    Sets the start delay on one of the animation objects used by this transition. The `transitionType` parameter determines the animation whose start delay is being set.
    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`, which determines the animation whose start delay is being set.
      `delay` - The length of time, in milliseconds, to delay before starting the animation.
    See Also:
      - `Animator.setStartDelay(long)`

  - ### getStartDelay

    public long getStartDelay(int transitionType)
    Gets the start delay on one of the animation objects used by this transition. The `transitionType` parameter determines the animation whose start delay is returned.
    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`, which determines the animation whose start delay is returned.
    Returns:
      long The start delay of the specified animation.
    See Also:
      - `Animator.getStartDelay()`

  - ### setDuration

    public void setDuration(int transitionType, long duration)
    Sets the duration on one of the animation objects used by this transition. The `transitionType` parameter determines the animation whose duration is being set.
    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`, which determines the animation whose duration is being set.
      `duration` - The length of time, in milliseconds, that the specified animation should run.
    See Also:
      - `Animator.setDuration(long)`

  - ### getDuration

    public long getDuration(int transitionType)
    Gets the duration on one of the animation objects used by this transition. The `transitionType` parameter determines the animation whose duration is returned.
    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`, which determines the animation whose duration is returned.
    Returns:
      long The duration of the specified animation.
    See Also:
      - `Animator.getDuration()`

  - ### setStagger

    public void setStagger(int transitionType, long duration)
    Sets the length of time to delay between starting each animation during one of the change animations.
    Parameters:
      `transitionType` - A value of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, or `CHANGING`.
      `duration` - The length of time, in milliseconds, to delay before launching the next animation in the sequence.

  - ### getStagger

    public long getStagger(int transitionType)
    Gets the length of time to delay between starting each animation during one of the change animations.
    Parameters:
      `transitionType` - A value of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, or `CHANGING`.
    Returns:
      long The length of time, in milliseconds, to delay before launching the next animation in the sequence.

  - ### setInterpolator

    public void setInterpolator(int transitionType, TimeInterpolator interpolator)
    Sets the interpolator on one of the animation objects used by this transition. The `transitionType` parameter determines the animation whose interpolator is being set.
    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`, which determines the animation whose interpolator is being set.
      `interpolator` - The interpolator that the specified animation should use.
    See Also:
      - `Animator.setInterpolator(TimeInterpolator)`

  - ### getInterpolator

    public TimeInterpolator getInterpolator(int transitionType)
    Gets the interpolator on one of the animation objects used by this transition. The `transitionType` parameter determines the animation whose interpolator is returned.
    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`, which determines the animation whose interpolator is being returned.
    Returns:
      TimeInterpolator The interpolator that the specified animation uses.
    See Also:
      - `Animator.setInterpolator(TimeInterpolator)`

  - ### setAnimator

    public void setAnimator(int transitionType, Animator animator)
    Sets the animation used during one of the transition types that may run. Any Animator object can be used, but to be most useful in the context of layout transitions, the animation should either be a ObjectAnimator or a AnimatorSet of animations including PropertyAnimators. Also, these ObjectAnimator objects should be able to get and set values on their target objects automatically. For example, a ObjectAnimator that animates the property "left" is able to set and get the `left` property from the View objects being animated by the layout transition. The transition works by setting target objects and properties dynamically, according to the pre- and post-layout values of those objects, so having animations that can handle those properties appropriately will work best for custom animation. The dynamic setting of values is only the case for the CHANGE animations; the APPEARING and DISAPPEARING animations are simply run with the values they have.

    It is also worth noting that any and all animations (and their underlying PropertyValuesHolder objects) will have their start and end values set according to the pre- and post-layout values. So, for example, a custom animation on "alpha" as the CHANGE_APPEARING animation will inherit the real value of alpha on the target object (presumably 1) as its starting and ending value when the animation begins. Animations which need to use values at the beginning and end that may not match the values queried when the transition begins may need to use a different mechanism than a standard ObjectAnimator object.

    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`, which determines the animation whose animator is being set.
      `animator` - The animation being assigned. A value of `null` means that no animation will be run for the specified transitionType.

  - ### getAnimator

    public Animator getAnimator(int transitionType)
    Gets the animation used during one of the transition types that may run.
    Parameters:
      `transitionType` - One of `CHANGE_APPEARING`, `CHANGE_DISAPPEARING`, `CHANGING`, `APPEARING`, or `DISAPPEARING`, which determines the animation whose animator is being returned.
    Returns:
      Animator The animation being used for the given transition type.
    See Also:
      - `setAnimator(int, Animator)`

  - ### setAnimateParentHierarchy

    public void setAnimateParentHierarchy(boolean animateParentHierarchy)
    This flag controls whether CHANGE_APPEARING or CHANGE_DISAPPEARING animations will cause the default changing animation to be run on the parent hierarchy as well. This allows containers of transitioning views to also transition, which may be necessary in situations where the containers bounds change between the before/after states and may clip their children during the transition animations. For example, layouts with wrap_content will adjust their bounds according to the dimensions of their children.

    The default changing transitions animate the bounds and scroll positions of the target views. These are the animations that will run on the parent hierarchy, not the custom animations that happen to be set on the transition. This allows custom behavior for the children of the transitioning container, but uses standard behavior of resizing/rescrolling on any changing parents.

    Parameters:
      `animateParentHierarchy` - A boolean value indicating whether the parents of transitioning views should also be animated during the transition. Default value is true.

  - ### isChangingLayout

    public boolean isChangingLayout()
    Returns true if animations are running which animate layout-related properties. This essentially means that either CHANGE_APPEARING or CHANGE_DISAPPEARING animations are running, since these animations operate on layout-related properties.
    Returns:
      true if CHANGE_APPEARING or CHANGE_DISAPPEARING animations are currently running.

  - ### isRunning

    public boolean isRunning()
    Returns true if any of the animations in this transition are currently running.
    Returns:
      true if any animations in the transition are running.

  - ### addChild

    public void addChild(ViewGroup parent, View child)
    This method is called by ViewGroup when a child view is about to be added to the container. This callback starts the process of a transition; we grab the starting values, listen for changes to all the children of the container, and start appropriate animations.
    Parameters:
      `parent` - The ViewGroup to which the View is being added.
      `child` - The View being added to the ViewGroup.

  - ### showChild

    public void showChild(ViewGroup parent, View child, int oldVisibility)
    This method is called by ViewGroup when a child view is about to be made visible in the container. This callback starts the process of a transition; we grab the starting values, listen for changes to all the children of the container, and start appropriate animations.
    Parameters:
      `parent` - The ViewGroup in which the View is being made visible.
      `child` - The View being made visible.
      `oldVisibility` - The previous visibility value of the child View, either `View.GONE` or `View.INVISIBLE`.

  - ### removeChild

    public void removeChild(ViewGroup parent, View child)
    This method is called by ViewGroup when a child view is about to be removed from the container. This callback starts the process of a transition; we grab the starting values, listen for changes to all the children of the container, and start appropriate animations.
    Parameters:
      `parent` - The ViewGroup from which the View is being removed.
      `child` - The View being removed from the ViewGroup.

  - ### hideChild

    public void hideChild(ViewGroup parent, View child, int newVisibility)
    This method is called by ViewGroup when a child view is about to be hidden in container. This callback starts the process of a transition; we grab the starting values, listen for changes to all the children of the container, and start appropriate animations.
    Parameters:
      `parent` - The parent ViewGroup of the View being hidden.
      `child` - The View being hidden.
      `newVisibility` - The new visibility value of the child View, either `View.GONE` or `View.INVISIBLE`.

  - ### addTransitionListener

    public void addTransitionListener(LayoutTransition.TransitionListener listener)
    Add a listener that will be called when the bounds of the view change due to layout processing.
    Parameters:
      `listener` - The listener that will be called when layout bounds change.

  - ### removeTransitionListener

    public void removeTransitionListener(LayoutTransition.TransitionListener listener)
    Remove a listener for layout changes.
    Parameters:
      `listener` - The listener for layout bounds change.

  - ### getTransitionListeners

    @Nullable public List<LayoutTransition.TransitionListener> getTransitionListeners()
    Gets the current list of listeners for layout changes.